#!/usr/bin/perl

$DIR = $ENV{'SCRIPT_FILENAME'}; $DIR =~ s/[a-z0-9_]*\.cgi//; chdir $DIR;

%v = &GetCgiVars;

if ($v{'annohr'} eq "1") { $annohr="T"; } else { $annohr="F"; }
if ($v{'annosp'} eq "1") { $annosp="T"; } else { $annosp="F"; }
if ($v{'show'}   eq "1") { $show  ="T"; } else { $show  ="F"; }
if ($v{'idena'}  eq "1") { $idena ="T"; } else { $idena ="F"; }
if ($v{'linie'}  eq "1") { $linie ="T"; } else { $linie ="F"; }

if ($v{'Submit'} eq "Get PostScript") {
  print "Content-type: application/postscript\n";
  print "Content-Disposition: attachment; filename=hr1.ps\n\n";
  $device="./hr1.ps/cps";
} else {
  print "Content-type: image/gif\n\n";
  $device="./hr1.gif/gif";
}

open (hr1,">hr1.in");
print hr1 <<EOF ;
hr1.$v{'metallicity'}.dat
$device
2			! ndat
general.dat    1  bright stars
cepheids.dat   8  cepheids
$v{'H_end'} $v{'He_end'} $v{'dHe_beg'}		! H_end, He_end, dHe_beg
$v{'sp'}	! sp(i),i=1,8
$v{'logTe_min'} $v{'logTe_max'} $v{'logL_min'} $v{'logL_max'}	! logTe_min, logTe_max, logL_min, logL_max
2.5 1.8			! menu_width, menu_aspect
$v{'hr_width'} $v{'hr_aspect'}		! hr_width, hr_aspect
$v{'hr_width'} $v{'hr_aspect'}		! gr_width, gr_aspect
10000			! nstepmax
11 10 1 5		! menu_col1, menu_col2, menu_col3, menu_col4
15 7 2 6 3 4 11 5 12 13	! composition colors
1 10 8 15 1 11 12 5 7 1	! gr_col(i),i=1,10
4 7 10			! h_col,he_col,other_col
2 8 7 3 1 4 6		! sp_col(i),i=1,7
$v{'lw1'} $v{'lw2'} $v{'chs'}			! lw1,lw2,chs
$annohr $annosp $show $idena $linie		! annohr,annosp,show,idena,linie
$v{'time'} $v{'dtime'} $v{'tend'} 		! time,dtime,tend
$v{'mass'} $v{'graph'} $v{'dat'}			! sta, gr, dat

EOF
close(hr1);

$out=qx!./hr1!;

if ($v{'Submit'} eq "Get PostScript") {
  open(hr1,"<./hr1.ps");
  read(hr1,$output,-s hr1);
  close(hr1);
} else {
  open(hr1,"<./hr1.gif");
  read(hr1,$output,-s hr1);
  close(hr1);
}

print $output;

exit;

sub GetCgiVars {
    local($in, %in) ;
    local($name, $value) ;


    # First, read entire string of CGI vars into $in
    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        $in = $ENV{'QUERY_STRING'} ;

    } elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        if ($ENV{'CONTENT_TYPE'}=~ m#^application/x-www-form-urlencoded$#i) {
            $ENV{'CONTENT_LENGTH'}
                || &PukeOnEm("No Content-Length sent with the POST request.");
            read(STDIN, $in, $ENV{'CONTENT_LENGTH'}) ;

        } else {
            &PukeOnEm("Unsupported Content-Type: $ENV{'CONTENT_TYPE'}") ;
        }

    } else {
        &PukeOnEm("Script was called with unsupported REQUEST_METHOD.") ;
    }

    # Resolve and unencode name/value pairs into %in
    foreach (split('&', $in)) {
        s/\+/ /g ;
        ($name, $value)= split('=', $_, 2) ;
        $name=~ s/%(..)/sprintf("%c",hex($1))/ge ;
        $value=~ s/%(..)/sprintf("%c",hex($1))/ge ;
        $in{$name}.= "\0" if defined($in{$name}) ;  # concatenate multiple var
        $in{$name}.= $value ;
    }

    return %in ;
}


# Die, outputting HTML error page
# If no $title, use a default title
sub PukeOnEm {
    local($msg,$title)= @_ ;
    $title || ($title= "CGI Error") ;
    print <<EOF ;
Content-type: text/html

<html>
<head>
<title>$title</title>
</head>
<body>
<h1>$title</h1>
<h3>$msg</h3>
<P>
<address>
Miroslav Broz, <a href="mailto:miroslav.broz\@usa.net">miroslav.broz\@usa.net</a>, Apr 8th 1998
</address>
</body>
</html>
EOF

    exit ;
}

###
# This sub disables HTML tags.  It will convert
# <> to &lt, &gt, in affect, making the tag appear
# to the reader as it was typed.
# It works like this: $myvarible = &RemoveHTML($myvarible);
#########################################################

sub RemoveHTML {
        local($input) = @_;
        $_ = $input;
        s/\</\&lt\;\&nbsp/g;
        s/\>/\&gt\;\&nbsp/g;
        $output = $_;
        return $output;
}


