c HR1 hrpack, creating binary dat files
c miroslav.broz@usa.net, http://www.kolej.mff.cuni.cz/~broz/hr1/

      program hrpack
c-----------------------------------------------------------------------

      include 'hr1.inc'

      integer i,j,nb
      character*80 filename,hr1datfile,explanation(nstamax)

c  read until end of comments
1     continue
        read(*,5) hr1datfile
5       format(a)
      if (hr1datfile(1:1).eq.'#') goto 1
      
      read(*,*) nsta
      do i=1,nsta
        read(*,10) filename,lrec(i),nrec(i),mass0(i),z(i),explanation(i)
10      format(a14,i4,i3,f8.2,f6.3,a)
        open(unit=1,name=filename)
        do j=1,nrec(i)
          read(1,20) nb,Age(j,i),Mass(j,i),logL(j,i),logTe(j,i),
     :      X(j,i),Y(j,i),C12(j,i),C13(j,i),N14(j,i),O16(j,i),
     :      O17(j,i),O18(j,i),Ne20(j,i),Ne22(j,i),QCC(j,i),
     :      logTu(j,i),logMdot(j,i),logrhoc(j,i),logTc(j,i),
     :      Xc(j,i),Yc(j,i),C12c(j,i),C13c(j,i),N14c(j,i),
     :      O16c(j,i),O17c(j,i),O18c(j,i),Ne20c(j,i),Ne22c(j,i)
20        format(i2,e15.7,f9.4,2f6.3,10f9.6,f9.4,f8.3,f7.3,2f6.3,
     :      10f9.6)
        enddo
        close(1)
      enddo

      open(unit=1,name=hr1datfile,form='unformatted',status='new',
     :  err=910)
      write(1) nsta
      do i=1,nsta
        write(1) lrec(i),nrec(i),mass0(i),z(i)
        do j=1,nrec(i)
          write(1) Age(j,i),Mass(j,i),logL(j,i),logTe(j,i),
     :      X(j,i),Y(j,i),C12(j,i),C13(j,i),N14(j,i),O16(j,i),O17(j,i),
     :      O18(j,i),Ne20(j,i),Ne22(j,i),QCC(j,i),logTu(j,i),
     :      logMdot(j,i),logrhoc(j,i),logTc(j,i),Xc(j,i),Yc(j,i),
     :      C12c(j,i),C13c(j,i),N14c(j,i),O16c(j,i),O17c(j,i),O18c(j,i),
     :      Ne20c(j,i),Ne22c(j,i)
        enddo
      enddo
      close(1)
      stop

900   write(*,901) filename
901   format('hrpack: Error reading file ',a)
      stop

910   write(*,911) hr1datfile
911   format('hrpack: Error writing file ',a)
      stop

      end

